/*
 * Right Encoding for Firefox
 * $Id: rightencoding.js 47 2014-05-31 11:37:54Z oops $
 */

var RightEncoding = {
	verbose: false,

	verboseMsg: function (str) {
		if ( this.verbose == false )
			return;

		alert (str);
		//console.log (str);
	},

	Status: function (event) {
		var g = gContextMenu;
		if ( g.isTextSelected || g.onLink || g.onImage || g.onAudio || g.onVideo || g.onTextInput || g.MailtoLink )
			RightEncoding.HideMenu ();
		else
			RightEncoding.ShowMenu ();
	},

	HideMenu: function () {
		document.getElementById ('rightencoding').hidden = true;
		document.getElementById ('context-sep-encoding').hidden = true;
		document.getElementById ('rightencoding-frame').hidden = true;
		document.getElementById ('context-sep-frame-encoding').hidden = true;
		return false;
	},

	ShowMenu: function () {
		document.getElementById ('rightencoding').hidden = false;
		document.getElementById ('context-sep-encoding').hidden = false;
		document.getElementById ('rightencoding-frame').hidden = false;
		document.getElementById ('context-sep-frame-encoding').hidden = false;
		return false;
	},

	/*
	 * XUL Menu API
	 */

	UpdateMenus: function (obj, event) {
		try {
			// over FF 30
			UpdateCurrentCharset (obj);
		} catch (e) {
			// under FF 29
			UpdateMenu (event);
		}
	},

	MultiplexHandler: function (event) {
		try {
			// beyong FF 30
			let toCharset = event.target.getAttribute('charset');

			if ( ! toCharset )
				throw "processiong FF 29";

			this.verboseMsg ('encoding changes to ' + toCharset);
			BrowserSetForcedCharacterSet (toCharset);
		} catch (e) {
			// for under 30
			this.verboseMsg (e);
			MultiplexHandler (event);
		}
	},

	MultiplexHandler_re: function (event) {
		try {

			var node = event.target;
			var name = node.getAttribute ('name');

			let frameNav = gContextMenu.target.ownerDocument.
					defaultView.QueryInterface (Ci.nsIInterfaceRequestor).
					getInterface (nsIWebNavigation);

			// for FF 29
			if ( name == "detectorGroup" ) {
				SelectDetector(event, false);
				this.FrameCharsetReload ();
				return;
			}

			let curCharset = frameNav.QueryInterface (Ci.nsIDocShell).
					QueryInterface (Ci.nsIDocCharset).
					charset;

			var toCharset = event.target.getAttribute('charset');
			// for FF 29
			if ( ! toCharset ) {
				toCharset = node.getAttribute ('id');
				toCharset = toCharset.substring (toCharset.indexOf('charset.') + 'charset.'.length);
			}

			this.verboseMsg (
					'Frame encoding changes to ' +
					toCharset + ' from ' + curCharset
			);

			frameNav.QueryInterface (Ci.nsIDocShell).
					QueryInterface (Ci.nsIDocCharset).
					charset = toCharset;

			this.FrameCharsetReload ();
		} catch (ex) { alert (ex); }
	},

	/*
	 * XUL Menu API END
	 */

	FrameCharsetReload: function () {
		gContextMenu.target.ownerDocument.
			defaultView.QueryInterface (Ci.nsIInterfaceRequestor).
			getInterface (nsIWebNavigation).
			reload (nsIWebNavigation.LOAD_FLAGS_CHARSET_CHANGE);
	},

	initialize: function (event) {
		// locaized description message
		var desc;
		var descstr;
		desc = Components.classes["@mozilla.org/preferences-service;1"].
				getService (Components.interfaces.nsIPrefService).
				getBranch ("extensions.rightencoding@oops.org.");
		descstr = Components.classes["@mozilla.org/supports-string;1"].
				createInstance (Components.interfaces.nsISupportsString);
		descstr.data = document.getElementById ('rightencoding-message').
				getString ('rightencoding.extension.desc');
		desc.setComplexValue ('description', Components.interfaces.nsISupportsString, descstr);

		var popMenu = document.getElementById ("contentAreaContextMenu");
		popMenu.addEventListener ("popupshowing", RightEncoding.Status, false);

		var parent = document.getElementById ("frame").firstChild;
		if ( parent ) {
			var child = document.getElementById ("context-sep-frame-encoding");
			parent.appendChild (child);
			var child = document.getElementById ("rightencoding-frame");
			parent.appendChild (child);
			window.removeEventListener ("load", RightEncoding.initialize, true);
		}
	}
};

window.addEventListener ("load", RightEncoding.initialize, true);
